#!/usr/bin/perl -T

# Copyright 1997 The Board of Trustees of 
# The Leland Stanford Junior University. All Rights Reserved.

# Communication to Jessica Shapiro (jessicas@stanford.edu)

use lib "/var/www/cgi-bin/FoldMiner2"; #needed so that Scop.pm is found?
use Scop qw($VERSION);
use CGI;

$sendmail = "/usr/sbin/sendmail";
$touch = "/bin/touch";
$lockprogram = "/usr/local/bin/lock2";
$lockhome = "/var/www/cgi-bin/FoldMiner2";
$databasedir = "/var/www/html/FoldMiner2/targetdb";
$ENV{'PATH'} = "/bin:/usr/bin:/usr/local/bin";


$tempfilename = shift(@ARGV); #this file contains alignment options, file locations, etc.
if($tempfilename =~ m|^/var/www/html/foldminertest/results/([0-9]+)|) {
  $ID = $1;
}
if($tempfilename =~ m|^(/var/www/html/FoldMiner2/results/[0-9]+/options.list)$|) {
  $tempfilename = $1;
}else {
#  print STDERR "problem with tempfilename ($tempfilename)\n";
  redirectToErrorHandler('',"An internal variable has an unexpected value.","","",$ID);
  exit(-1);
}


open(tempin, "<$tempfilename") || die "can't open $tempfilename: $!\n";

$outputdir = <tempin>;
$wwwoutput = <tempin>;
$query = <tempin>;
$querychainopt = <tempin>;
$target = <tempin>;
$seqpairsoption = <tempin>;
$distthreshold = <tempin>;
$queryoutname = <tempin>;
$querywwwlink = <tempin>;
$address = <tempin>;
$expectation = <tempin>;
$xval = <tempin>;
$base = <tempin>;
$exponent = <tempin>;
$chime = <tempin>;
close(tempin);

#`/sbin/rm $tempfilename`;

chop($outputdir);
chop($wwwoutput);
chop($query);
chop($querychainopt);
chop($target);
chop($seqpairsoption);
chop($distthreshold);
chop($queryoutname);
chop($querywwwlink);
chop($address);
chop($expectation);
chop($xval);
chop($base);
chop($exponent);
chop($chime);

#check syntax of options read in above, though it's unlikely that there will be a problem
if($outputdir =~ m|^(/var/www/html/FoldMiner2/results/[0-9]+)$|) {
  $outputdir = $1;
}else {
  #print "problem with outputdir ($outputdir)\n";  
  redirectToErrorHandler('',"An internal variable (outputdir) has an unexpected value.","","",$ID);exit(-1);
}

if($wwwoutput =~ m|^(/FoldMiner2/results/[0-9]+)$|) {
  $wwwoutput = $1;
}else {redirectToErrorHandler('',"An internal variable (wwwoutput) has an unexpected value.","","",$ID);exit(-1);}

if($querychainopt =~ /^(-qc [A-Z0-9])$/) { 
  $querychainopt = $1;
}elsif($querychainopt =~ /^(\s*)$/) { #$querychainopt does not necessarily exist
  $querychainopt = $1;
}else {redirectToErrorHandler('',"An internal variable (querychainopt) has an unexpected value.","","",$ID);exit(-1);}

if($seqpairsoption =~ /^(-s)$/) {
  $seqpairsoption = $1;
}elsif($seqpairsoption =~/^()$/) {
  $seqpairsoption = $1;
}else {redirectToErrorHandler('',"An internal variable (seqpairsoption) has an unexpected value.","","",$ID);exit(-1);}

if($distthreshold =~ /^([0-9]*)(\.?[0-9]*)?$/) {
  $distthreshold = $1;
}else { redirectToErrorHandler('',"An internal variable (distthreshold) has an unexpected value.","","",$ID);exit(-1);}

if(length($query) == 7) { #scop id
  $query = securityCheckProteinName($query,1);
}elsif(length($query) == 4 || length($query)==6) { #pdb id, with or without chain
  $query = securityCheckProteinName($query,0);
}elsif($query =~m|^($outputdir/queryfile\.pdb)$|) { #came from pdbpaste1
  $query = $1;
}else {
  $query = "";
}

if(length($target) == 7) { #scop id
  $target = securityCheckProteinName($target,1); 
}elsif(length($target)==4 || length($target)==6) { #pdb id, with or without chain
  $target = securityCheckProteinName($target,0);
}elsif($target =~ m|^($outputdir/targetfile\.pdb)$|) { #came from pdbpaste2
  $target = $1;
}else {
  $target = checkTargetDBFilename($target);
}

if($target eq "" || $query eq "") {
#  print STDERR "problem with query ($query) or target ($target)\n";
  redirectToErrorHandler('',"An internal variable (query or target) has an unexpected value.","","",$ID);
  exit(-1);
}



if($queryoutname =~ /^(query)$/) { #came from pdbpaste1
  $queryoutname = $1;
}elsif(length($queryoutname)==7) { #scopid
  $queryoutname = securityCheckProteinName($queryoutname,1);
}else {
  $queryoutname = securityCheckProteinName($queryoutname,0);
}
if($queryoutname eq "") {
#  print STDERR "problem with queryoutname\n";
  redirectToErrorHandler('',"An internal variable (queryoutname) has an unexpected value.","","",$ID);
  exit(-1);
}


if($querywwwlink =~ m|^(http://scop\.mrc-lmb\.cam\.ac\.uk/scop/search\.cgi\?sid=$queryoutname)$|) { #scop id
  $querywwwlink = $1;
}elsif($querywwwlink =~ m|^(http://scop.berkeley.edu/search\.cgi\?sid=$queryoutname)$|) {
  $querywwwlink = $1;
}elsif($querywwwlink =~ m|^(/cgi-bin/FoldMiner2/browse2\.cgi\?pdbname=$queryoutname\&resultsdir=$outputdir\&wwwdir=$wwwoutput)$|) { #pdb id; syntax may change
  $querywwwlink = $1;
}elsif($querywwwlink =~ m|^(/cgi-bin/FoldMiner2/browse2.cgi\?pdbname=queryfile\&resultsdir=$outputdir\&wwwdir=$wwwoutput)$|) { #comes from file upload
  $querywwwlink = $1;
}else {
  $querywwwlink = "";
}
if($querywwwlink eq "") {
 # print STDERR "problem with querywwwlink\n";
  redirectToErrorHandler('',"An internal variable (querywwwlink) has an unexpected value.","","",$ID);
  exit(-1);
}

if($base =~ /^([0-9]+)(\.[0-9]*)$/) {
  $base = $1.$2;
}elsif($base =~ /^([0-9]+e-?[0-9]+)?$/) {
  $base = $1;
}else {redirectToErrorHandler('',"An internal variable (base) has an unexpected value.","","",$ID); exit(-1);}

if($exponent =~ /^(-?[0-9])+$/) {
  $exponent = $1;
}else { redirectToErrorHandler('',"An internal variable (exponent) has an unexpected value.","","",$ID);exit(-1);}

#need to check address!! Adapted from http://www.lyris.com/lm_help/6.0/HowDoIValidateEmailAddress.html
if($address =~ /^(NONE)$/) {
  $address = $1;
}elsif($address =~ m|^[\s\n\r]*\"?([^\"]+\"?@[^ <>\t].[^ <>\t][^ <>\t]+)[\s\n\r]*$|) {
  $address = $1;
}else { redirectToErrorHandler('',"An internal variable (address) has an unexpected value.","","",$ID);exit(-1);}

if($expectation =~ /e/) {
  if($expectation =~ /^([0-9]+e-?[0-9]+)$/) {
    $expectation = $1;
  }else { redirectToErrorHandler('',"An internal variable (expectation) has an unexpected value.","","",$ID);exit(-1);}
}elsif($expectation =~/[0-9]/) {
  if($expectation =~ /\./) {
    if($expectation =~/^([0-9]*)(\.[0-9]*)$/) {
      $expectation = $1.$2;
    }else { redirectToErrorHandler('',"An internal variable (expectation) has an unexpected value.","","",$ID);exit(-1);}
  }elsif($expectation =~/^([0-9]+)$/) {
    $expectation = $1;
  }else {
    redirectToErrorHandler('',"An internal variable (expectation) has an unexpected value.","","",$ID);exit(-1);
  }
}else {
   redirectToErrorHandler('',"An internal variable (expectation) has an unexpected value.","","",$ID);exit(-1);
}

if($xval =~ /^([10])?(\.[0-9]*)?$/) {
  $xval = $1.$2;
  $xval += 0; #make sure it's interpreted as a number
  if($xval < 0 || $xval > 1) {
 #   print STDERR "xval ($xval) is outside the interval [0,1]\n";
    redirectToErrorHandler('',"An internal variable (xval) has an unexpected value.","","",$ID);
    exit(-1);
  }
}else { redirectToErrorHandler('',"An internal variable (xval) has an unexpected value.","","",$ID);exit(-1);}

if($chime =~/^([01])$/) {
  $chime = $1;
}else {
#  print STDERR "problem with chime ($chime)\n";
  redirectToErrorHandler('',"An internal variable (chime) has an unexpected value.","","",$ID);
  exit(-1);
}


open(OLD_STDOUT, ">&STDOUT"); #save STDOUT filehandle
open(STDOUT, ">$outputdir/logfile"); #redirect standard out to log file
select(STDOUT); $| = 1;
`$lockprogram -d $distthreshold -q $query $querychainopt -t $target -o $outputdir $seqpairsoption > $outputdir/logfile`;
#system($lockprogram, "-d", $distthreshold, "-q", $query, $querychainopt, "-t", $target, "-o", $outputdir,$seqpairsoption);
system($touch,"$outputdir/done"); #indicates that search is done
close(STDOUT);
open(STDOUT, ">&OLD_STDOUT");
open(LOG, "$outputdir/logfile");
@lines = <LOG>;
close(LOG);

#check to see if alignments were run
if(!(-e "$outputdir/search.out")) {
#  print STDERR "$outputdir/search.out not found: redirecting to error handler\n";
  $errorline = "";
  for($i=0;$i<=$#lines;$i++) {
    if($lines[$i] =~ /(Sorry\.?\s*)(.*)/) {
      if($lines[$i] =~ /No CA atoms with chain identifier/) {
	$errorline .= $lines[$i];
    }else {
	$errorline .= "Could not find or create a DSSP file for the query structure. It is necessary to produce a DSSP file in order to obtain secondary structure definitions when they are not included in the PDB file itself. If you'd like to use this query structure, please add HELIX and/or SHEET headers to the PDB file and upload it again.";
    }
}
  }
  print STDERR "errorline: $errorline\n";
  redirectToErrorHandler("","$errorline","","",$ID);
  exit(-1);
}

if($lines[0] =~ /^attempting to find file: $query/) {
  if($lines[2] =~/Could not find file $query/) {
    redirectToErrorHandler($query,"The query PDB file could not be located in our local database. If there are no errors in your input, please repeat your request and upload the PDB file.","d1f5wa1,1f5w,1f5w-A","query",$ID);
    exit(-1);
  }
}

$ENV{'REQUEST_METHOD'}="GET";
$ENV{'QUERY_STRING'}="&query=$query&expectation=$expectation&xval=$xval&resultsdir=$wwwoutput&querylink=$querywwwlink&iter=1&newsearch=0&db=$target&base=$base&exponent=$exponent&xval=$xval&chime=$chime&filenum=1";
$error = system("./findmotif.cgi", "\"&query=$query&expectation=$expectation&xval=$xval&resultsdir=$wwwoutput&querylink=$querywwwlink&iter=1&newsearch=0&db=$target&exponent=$exponent&xval=$xval&base=$base&chime=$chime&filenum=1\"");



if ($address ne "NONE") {
  my($directory);
  if($wwwoutput =~ m|^(/.*)+/([0-9]+)$|) {
    $directory = $2;
  }
  open(MAIL, "|$sendmail -t") || print STDERR "can't open $sendmail: $!\n"; #need to handle errors
  print MAIL <<END;
To: $address
From: FoldMiner server <jessicas\@leland.stanford.edu>
Subject: Your FoldMiner results are ready

Your FoldMiner structural similarity search and motif discovery results are ready. They are available at:

 http:\/\/dlb3.stanford.edu$wwwoutput/results.html

Results may be deleted after 72 hours in order to make the space available to other users.

Please send comments, questions, and bug reports to jessicas@stanford.edu, and include the number $directory.

Thank you,

Jessica Shapiro
END
close(MAIL);

}



exit(0);



#############################################

    
    
sub printlongtableline () {
	
    chop($_[0]);
    @fields = split /\s+/, $_[0];
    
    if(1) { #eventually put expectation check here (only print lines with low enough pvals)
	
	$target = $fields[0];
	($shortpdbname) = $target =~ /^.(....)/;
	($shortscopname) = $target =~/^(.......)/; #remove any filename extensions
	$targetscoplink = "http://scop.mrc-lmb.cam.ac.uk/scop/search.cgi?sid=$shortscopname";

	print searchtable "<tr>\n";
	print searchtable "<td align=left>";
	print searchtable "<a href=$targetscoplink target=$shortscopname>$target</a></font></td>\n";
	print searchtable "<td align=center>";
	print searchtable "<a href=$wwwoutput/$queryoutname\_$target\.out>Text</a>";
	print searchtable " , ";
	print searchtable "<a href=/cgi-bin/FoldMiner2/newpdb.cgi?yourfile=$queryoutname\_$target\.out\&outfile=$queryoutname\_$target\.pdb\&outdir=$outputdir\&wwwdir=$wwwoutput\&chime=0>PDB</a>";

	print searchtable " , ";
	print searchtable "<a href=/cgi-bin/FoldMiner2/newpdb.cgi?yourfile=$queryoutname\_$target\.out\&outfile=$queryoutname\_$target\.pdb\&outdir=$outputdir\&wwwdir=$wwwoutput\&chime=1>Chime</a>";

	
	
	print searchtable "</td>\n";
	print searchtable "<td align=center>";
	print searchtable "$fields[1]</td>\n";
	print searchtable "<td align=center>";
	print searchtable "?</td>\n";
	print searchtable "<td align=center>";
	print searchtable "$fields[2]</td>\n";
	print searchtable "<td align=center>";
	print searchtable "$fields[3]</td>";
	print searchtable "<td align=center>";
	print searchtable "$fields[4]</td>\n";
	print searchtable "<td align=left>";
	print searchtable "<font size=-1>";
	for ($i = 5; $i <= $#fields; $i++) {
	    print searchtable "$fields[$i] ";
	}
	print searchtable "</font></td>\n";
	print searchtable "</tr>\n";
    }

}
    
sub printHeader() {
  print searchtable "<html>\n";
  print searchtable  "<head><link rel=stylesheet href=\"/FoldMiner2/lock.css\" type=\"text/css\"></head>\n";
  print searchtable "<body bgcolor=#FFFFFF link=#26256b alink=#877bab vlink=#877bab>\n";
}

#this page sets up the frames
sub printMainPage() {
print mainhtml <<END
<html>
<head>
<meta http-equiv=description name=description 
content="LOCK, output, FoldMiner">
<meta http-equiv=keywords name=keywords 
content="hierarchical protein structure superposition, bioinformatics, LOCK, LOCK 2.0, biochemistry, alignment","FoldMiner">
<title>FoldMiner Search Results</title>
</head>
     <frameset cols = "50%, 50%">
         <frameset  rows= "60%, 40%">
            <frame src="/FoldMiner2/motif.html">
            <frame src="/FoldMiner2/iteratesearch.html">
         </frameset>
         <frame src = "table.html">
     </frameset>
</head>
</html>
END
}


#check to be sure that the filename is actually one of the astral files
#Also sets databasesize since it's extracting the info needed to do that anyway
sub checkTargetDBFilename {
  my($filename) = @_;

  if($filename =~m|^$databasedir/astral-scopdom-seqres-gd-sel-gs-bib|) { #using % identity
    if($filename =~ m|^($databasedir/astral-scopdom-seqres-gd-sel-gs-bib-)([0-9]{2,3})(-$VERSION.id)|) {
      $filename = $1.$2.$3;
    }else {
      $filename = "";
    }
  }elsif($filename =~m|^($databasedir/astral-scopdom-seqres-gd-sel-gs-sc-)([a-z]{2})(-$VERSION.id)|) {#using hierarchy representatives
    if(($2 eq "cl" || $2 eq "cf" || $2 eq "sf" || $2 eq "fa" || $2 eq "dm")) {
      $filename = $1.$2.$3;
    }else {
      $filename = "";
    }
  }else { #filename not recognzied (not one of the astral files)
    return "";
  }

}

sub securityCheckProteinName {
  my($inputname, $isScop) = @_;
  my($cleanname,$pdbid);
  
  $cleanname = "";
  if($isScop) {
    $inputname =~ /^([dg][0-9][A-Za-z0-9]{3}[\._A-Za-z0-9][_0-9])/;
    $cleanname = $1;
  }else {
    $inputname =~/^([0-9][A-Za-z0-9]{3})(-[A-Za-z0-9])?/;
    $cleanname = $1.$2; #$1 is the pdb id, and $2 is the chain, prefixed by '-'
  }
  return $cleanname; #need to do error checking -- could return empty string
}

sub redirectToErrorHandler {
  my($input,$error,$correctinput,$helptopic,$pid) = @_;
  my($email) = "jessicas\@stanford.edu";
  my($name) = "Jessica Ebert";
  my($runtype) = "search"; #right now runlock.pl is only called for FoldMiner

  $input=CGI::escape($input);
  $error = CGI::escape($error);
  $correctinput=CGI::escape($correctinput);
  $helptopic=CGI::escape($helptopic);
  $email=CGI::escape($email);
  $name=CGI::escape($name);


 open(OLD_STDOUT, ">&STDOUT"); #save STDOUT filehandle
  open(STDOUT, ">$outputdir/results.html"); #redirect standard out to log file
  select(STDOUT); $|=1;
  $ENV{'REQUEST_METHOD'}="GET";
  $ENV{'QUERY_STRING'}="&error=$error&exampleinput=$correctinput&input=$input&email=$email&name=$name&helptopic=$helptopic&resultsdir=$pid&runtype=$runtype";
  system("./reporterror.cgi","\"?error=$error&exampleinput=$correctinput&input=$input&email=$email&name=$name&helptopic=$helptopic&resultsdir=$pid&runtype=$runtype\"");
  close(STDOUT);
  open(IN, "$outputdir/results.html");
  @lines = <IN>;shift(@lines);shift(@lines);
  close(IN);
  open(OUT, ">$outputdir/results.html");
  print OUT @lines;
  close(OUT);
  open(STDOUT, ">$outputdir/table1.html");
  close(STDOUT);
  
  open(STDOUT,">&OLD_STDOUT");

}
